# Record Class CASyntaxRuleBranch

java.lang.Object
java.lang.Record
com.io7m.cardant.parsers.CASyntaxRuleBranch

Record Components:
  `name` - The name
  `subRules` - The rules
  `examples` - The examples

All Implemented Interfaces:
  `CASyntaxRuleType`, `Comparable<CASyntaxRuleType>`

public record CASyntaxRuleBranch(String name, List<String> subRules, List<String> examples) extends Record implements CASyntaxRuleType
A syntax rule consisting of a set of sub rules.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CASyntaxRuleBranch(String name, List<String> subRules, List<String> examples)`
  A syntax rule consisting of a set of sub rules.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `compareTo(CASyntaxRuleType o)`
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `List<String>`
  `examples()`
  Returns the value of the `examples` record component.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `String`
  `name()`
  Returns the value of the `name` record component.
  `List<String>`
  `subRules()`
  Returns the value of the `subRules` record component.
  `String`
  `text()`
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CASyntaxRuleBranch

    public CASyntaxRuleBranch(String name, List<String> subRules, List<String> examples)
    A syntax rule consisting of a set of sub rules.
    Parameters:
      `name` - The name
      `subRules` - The rules
      `examples` - The examples

- ## Method Details

  - ### text

    public String text()
    Specified by:
      `text` in interface `CASyntaxRuleType`
    Returns:
      The rule text

  - ### compareTo

    public int compareTo(CASyntaxRuleType o)
    Specified by:
      `compareTo` in interface `Comparable<CASyntaxRuleType>`

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### name

    public String name()
    Returns the value of the `name` record component.
    Specified by:
      `name` in interface `CASyntaxRuleType`
    Returns:
      the value of the `name` record component

  - ### subRules

    public List<String> subRules()
    Returns the value of the `subRules` record component.
    Specified by:
      `subRules` in interface `CASyntaxRuleType`
    Returns:
      the value of the `subRules` record component

  - ### examples

    public List<String> examples()
    Returns the value of the `examples` record component.
    Specified by:
      `examples` in interface `CASyntaxRuleType`
    Returns:
      the value of the `examples` record component